﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication31
{
    public partial class Form1 : Form
    {
        System.Globalization.CultureInfo usCulture = new System.Globalization.CultureInfo("en-US");
        System.Globalization.CultureInfo germanCulture = new System.Globalization.CultureInfo("de-DE");

        public Form1()
        {
            InitializeComponent();
                        

            //System.Threading.Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("de-DE");
            //System.Threading.Thread.CurrentThread.CurrentUICulture = new System.Globalization.CultureInfo("de-DE");

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();
            dt.Columns.Add("Decimal", typeof(decimal));
            dt.Columns.Add("Decimal 2", typeof(decimal));

            for (int i = 0; i < 10; i++)
            {
                decimal d = DummyDataCreator.RandomInt(0, 100000000);
                d = d / 100M;

                dt.Rows.Add(new object[] { d, d });
            }

            this.ultraGrid1.SetDataBinding(dt, null);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var band = layout.Bands[0];

            var summarySettings = band.Summaries.Add(SummaryType.Maximum, band.Columns["Decimal"]);

            this.VerifyCulture();
        }

        private void VerifyCulture()
        {
            var layout = this.ultraGrid1.DisplayLayout;
            var band = layout.Bands[0];
            var column1 = band.Columns[1];

            column1.Format = this.textBox1.Text;

            var summarySettings = band.Summaries[0];

            if (this.radioButton1.Checked)
            {
                column1.FormatInfo = usCulture;
                summarySettings.DisplayFormatProvider = usCulture;

            }
            else
            {
                column1.FormatInfo = germanCulture;
                summarySettings.DisplayFormatProvider = germanCulture;
            }

            summarySettings.DisplayFormat = "{0:" + this.textBox1.Text + "}";
            
            this.ultraGrid1.Rows.Refresh(RefreshRow.FireInitializeRow);
        }

        private void radioButton_CheckedChanged(object sender, EventArgs e)
        {
            this.VerifyCulture();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            this.VerifyCulture();
        }
    }
}
